#!/usr/local/bin/perl

#
# JOYFUL NOTE : regist.cgi - 2012/03/07
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use Jcode;

# ݒt@CF
require "./init.cgi";
my %cf = &init;

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&error('eʃI[o[') if ($cgi->truncated);
my %in = &parse_form($cgi);

if ($in{mode} eq "regist") { &regist; }
if ($in{mode} eq "log_edit") { &log_edit; }
if ($in{mode} eq "log_dele") { &log_dele; }
&error("sȏł");

#-----------------------------------------------------------
#  eLt
#-----------------------------------------------------------
sub regist {
	# tH[̓`FbN
	&form_check;

	# eL[`FbN
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			&error("eL[͕słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}

		# eL[`FbN
		# -1 : L[sv
		#  0 : ԃI[o[
		#  1 : L[v
		my $chk = cap::check($in{captcha}, $in{str_crypt}, $cf{captcha_key}, $cf{cap_time}, $cf{cap_len});
		if ($chk == 0) {
			&error("eL[Ԃ𒴉߂܂B<br>etH[ɖ߂čēǍ݌Aw̐ē͂Ă");
		} elsif ($chk == -1) {
			&error("eL[słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}
	}

	# R[hϊ
	Jcode::convert(\$in{name}, 'sjis');
	Jcode::convert(\$in{sub}, 'sjis');
	Jcode::convert(\$in{comment}, 'sjis');

	# zXg擾
	my ($host,$addr) = &get_host;

	# Ԏ擾
	my ($date,$time) = &get_time;

	# OJ
	my @data;
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;

	# LNO
	my ($no, $ip, $time2) = split(/<>/, $top);
	$no++;

	# Ae`FbN
	if ($addr eq $ip && $cf{wait} > $time - $time2) {
		close(DAT);
		&error("Ae͂΂炭Ԃĉ");
	}

	# Abv[h
	my ($ext,$w,$h);
	if ($in{upfile}) {
		($ext,$w,$h) = &upload($no);
	}

	# 폜L[Í
	my $crypt = &encrypt($in{pwd}) if ($in{pwd} ne "");

	# eL̏ꍇ
	my @past;
	if ($in{reno} eq "") {
		my ($i,$stop);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);
			if ($reno2 eq "") { $i++; }
			if ($i > $cf{max} - 1 && $reno2 eq "") { $stop = 1; }
			if (!$stop) {
				push(@data,$_);
			} else {
				# ߋO
				if ($cf{pastkey}) { push(@past,$_); }

				# Ytt@C폜
				if ($ex2) { unlink("$cf{imgdir}/$no2$ex2"); }
			}
		}
		unshift(@data,"$no<><>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		unshift(@data,"$no<>$addr<>$time<>\n");

		# ߋOXV
		if (@past > 0) { &make_past(@past); }

	# XLFgbv\[g
	} elsif ($in{reno} && $cf{topsort}) {

		my ($flg,$match,@tmp);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);

			# eL
			if ($in{reno} == $no2) {
				if ($reno2) { $flg = 1; last; }
				$match = 1;
				push(@data,$_);

			# XL
			} elsif ($in{reno} == $reno2) {
				push(@data,$_);

			# eL̒ɒu
			} elsif ($match == 1 && $in{reno} != $reno2) {
				$match = 2;
				push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
				push(@tmp,$_);

			} else {
				push(@tmp,$_);
			}
		}
		if ($flg || !$match) {
			close(DAT);
			&error("sȕԐMvł");
		}

		# ŏ̃XL̃P[X
		if ($match == 1) {
			push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		}
		# XLPgbv
		push(@data,@tmp);
		unshift(@data,"$no<>$addr<>$time<>\n");

	# XLFgbv\[gȂ
	} else {

		my ($flg,$match);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);

			if ($match == 0 && $in{reno} == $no2) {
				if ($reno2) { $flg = 1; last; }
				$match = 1;

			} elsif ($match == 1 && $in{reno} != $reno2) {
				$match = 2;
				push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
			}
			push(@data,$_);
		}
		if ($flg || !$match) {
			close(DAT);
			&error("sȕԐMvł");
		}

		if ($match == 1) {
			push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		}
		unshift(@data,"$no<>$addr<>$time<>\n");
	}

	# XV
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# NbL[i[
	&set_cookie($in{name},$in{email},$in{url},$in{color});

	# [ʒm
	if ($cf{mailing} == 1) {
		my $clip = "$no$ext" if ($ext);
		&mail_to($date,$host,$clip);
	}

	# 
	&message("肪Ƃ܂BL󗝂܂B");
}

#-----------------------------------------------------------
#  [UL폜
#-----------------------------------------------------------
sub log_dele {
	if ($in{no} eq '' || $in{pwd} eq '') {
		&error("LNo܂͍폜L[̓ł");
	}

	my ($top,$flg,$oya_flg,@data);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		# YL
		if ($in{no} == $no) {
			$oya_flg = 1;
			$flg = 1;
			if ($pw eq '') {
				$flg = 2;
				last;
			}
			# 폜L[ƍ
			if (&decrypt($in{pwd},$pw) != 1) {
				$flg = 3;
				last;
			}
			# Ytt@C폜
			if ($ext) { unlink("$cf{imgdir}/$no$ext"); }
			next;

		# eL폜ꍇ̓XL폜
		} elsif ($oya_flg && $in{no} == $reno) {

			# Ytt@C폜
			if ($ext) { unlink("$cf{imgdir}/$no$ext"); }
			next;
		}
		push(@data,$_);
	}
	if (!$flg) {
		close(DAT);
		&error("YL܂");
	} elsif ($flg == 2) {
		close(DAT);
		&error("YLɂ͍폜L[ݒ肳Ă܂");
	} elsif ($flg == 3) {
		close(DAT);
		&error("폜L[Ⴂ܂");
	}

	# XV
	seek(DAT, 0, 0);
	print DAT $top;
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 
	&message("L폜܂");
}

#-----------------------------------------------------------
#  LC
#-----------------------------------------------------------
sub log_edit {
	if ($in{no} eq '' || $in{pwd} eq '') {
		&error("LNo܂͈Ï؃L[̓ł");
	}

	# s
	if ($in{job} eq "edit") {

		# tH[̓`FbN
		&form_check;

		# R[hϊ
		Jcode::convert(\$in{name}, 'sjis');
		Jcode::convert(\$in{sub}, 'sjis');
		Jcode::convert(\$in{comment}, 'sjis');

		my ($flg,$ext2,$w2,$h2,@data);
		open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $no) {
				$flg = 1;
				if ($pw eq '') {
					$flg = -1;
					last;
				}
				# 폜L[ƍ
				if (&decrypt($in{pwd},$pw) != 1) {
					$flg = -2;
					last;
				}

				# Abv[h
				if ($in{upfile}) {
					($ext2,$w2,$h2) = &upload($in{no});
				}

				# 摜폜
				if ($in{imgdel}) {
					unlink("$cf{imgdir}/$in{no}$ext");
					$ext = $w = $h = '';
				}

				# YtAbv[h̏ꍇ
				if ($ext2) {
					# gqύX̏ꍇt@C폜
					if ($ext && $ext2 ne $ext) {
						unlink("$cf{imgdir}/$in{no}$ext");
					}
					# VYtt@C
					($ext,$w,$h) = ($ext2,$w2,$h2);
				}
				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$ext<>$w<>$h<>0<>\n";
			}
			push(@data,$_);
		}

		# XV
		seek(DAT, 0, 0);
		print DAT $top;
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		if ($flg < 1) { &error("sȏł"); }

		# bZ[W
		&message("C܂");
	}

	my ($flg,$log);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		if ($in{no} == $no) {
#			if ($reno) { $resmd = 1; }

			$flg = 1;
			if ($pw eq '') {
				$flg = -1;
			}
			# 폜L[ƍ
			if (&decrypt($in{pwd},$pw) != 1) {
				$flg = -2;
			}
			$log = $_;
			last;
		}
	}
	close(IN);

	# 
	if (!$flg) {
		&error("YL܂");
	} elsif ($flg == -1) {
		&error("YLɂ͍폜L[ݒ肳Ă܂");
	} elsif ($flg == -2) {
		&error("폜L[Ⴂ܂");
	}

	# s
	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/, $log);
	$com =~ s/<br>/\n/g;
	$url ||= 'http://';

	# FI{^
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# CtH[
	open(IN,"$cf{tmpldir}/edit.html") or &error("open err: edit.html");
	print "Content-type: text/html\n\n";
	while(<IN>) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!num!/$in{no}/g;
		s/!pwd!/$in{pwd}/g;
		s/!name!/$name/g;
		s/!email!/$eml/g;
		s/!sub!/$sub/g;
		s/!comment!/$com/g;
		s/!url!/$url/g;
		s/!color!/$color/g;

		print;
	}
	close(IN);
	exit;
}

#-----------------------------------------------------------
#  ߋO
#-----------------------------------------------------------
sub make_past {
	my @past = @_;

	# ߋONOt@C
	open(NO,"+< $cf{nofile}") or &error("open err: $cf{nofile}");
	eval "flock(NO, 2);";
	my $num = <NO>;

	# ߋO`
	my $pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

	# ߋOJ
	open(LOG,"+< $pastfile") or &error("open err: $pastfile");
	eval "flock(LOG, 2);";
	my @data = <LOG>;

	# KsI[o[At@C
	if (@data > $cf{pastmax}) {

		# ߋO
		@data = ();
		close(LOG);

		# ߋNOXV
		seek(NO, 0, 0);
		print NO ++$num;
		truncate(NO, tell(NO));
		close(NO);

		$pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

		open(LOG,"+> $pastfile");
		eval "flock(LOG, 2);";
		print LOG @past;
		close(LOG);

		chmod(0666, $pastfile);

	# K
	} else {

		# ߋNOt@C
		close(NO);

		# ߋOXV
		seek(LOG, 0, 0);
		print LOG @past;
		print LOG @data;
		truncate(LOG, tell(LOG));
		close(LOG);
	}
}

#-----------------------------------------------------------
#  tH[̓`FbN
#-----------------------------------------------------------
sub form_check {
	# svsJbg
	$in{sub}  =~ s/<br>//g;
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{captcha} =~ s/<br>//g;
	$in{color} =~ s/<br>//g;
	$in{comment} =~ s/(<br>)+$//g;

	# `FbN
	if ($cf{no_wd}) { &no_wd; }
	if ($cf{jp_wd}) { &jp_wd; }
	if ($cf{urlnum} > 0) { &urlnum; }

	# ͒l
	if ($in{url} eq 'http://') { $in{url} = ''; }
	$in{sub} ||= "";

	# ͍ڃ`FbN
	my $err;
	if (length($in{sub}) > $cf{sub_len}*2) {
		$err .= "^Cg͑Sp$cf{sub_len}ȓł<br>";
	}
	if ($in{name} eq "") { $err .= "O͂Ă܂<br>"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,}$/) {
		$err .= "d[͓̓esł<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "URL񂪕sł<br>";
	}
	&error($err) if ($err);
}

#-----------------------------------------------------------
#  [M
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host,$clip) = @_;

	# [^Cg`
	my $msub = Jcode->new("BBS : $in{sub}")->mime_encode;

	# Rg̉s
	my $com = $in{comment};
	$com =~ s/<br>/\n/g;
	$com =~ s/&lt;/>/g;
	$com =~ s/&gt;/</g;
	$com =~ s/&quot;/"/g;
	$com =~ s/&amp;/&/g;
	$com =~ s/&#39;/'/g;

	# [{`
	my $mbody = <<"EOM";
fɓe܂B

eF$date
zXgF$host

  F$in{sub}
OF$in{name}
E-mailF$in{email}
URL   F$in{url}
Yt  F$clip

$com
EOM

	# JISR[hϊ
	Jcode::convert(\$mbody, 'jis', 'sjis');

	# [AhXȂꍇ͊Ǘ҃[ɒu
	$in{email} ||= $cf{mailto};

	# sendmailR}h
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $in{email}";
	}

	# M
	open(MAIL,"| $scmd") or &error("Ms");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $in{email}\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# ̃tH[}bg
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  ֎~[h`FbN
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{sub} $in{comment}", $_) >= 0) {
			$flg = 1;
			last;
		}
	}
	if ($flg) { &error("֎~[h܂܂Ă܂"); }
}

#-----------------------------------------------------------
#  {`FbN
#-----------------------------------------------------------
sub jp_wd {
	if ($in{comment} !~ /[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]/) {
		&error("bZ[Wɓ{ꂪ܂܂Ă܂");
	}
}

#-----------------------------------------------------------
#  URL`FbN
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{comment};
	my ($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		&error("RgURLAhX͍ő$cf{urlnum}܂łł");
	}
}

#-----------------------------------------------------------
#  zXg擾
#-----------------------------------------------------------
sub get_host {
	# IP&zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IP`FbN
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		&error("ANZXĂ܂");

	# zXg`FbN
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			&error("ANZXĂ܂");
		}
	}
	$host ||= $addr;
	return ($host, $addr);
}

#-----------------------------------------------------------
#  cryptÍ
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  cryptƍ
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  bZ[W
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/message.html") or &error("open err: message.html");
	print "Content-type: text/html\n\n";
	while(<IN>) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!message!/$msg/g;

		print;
	}
	close(IN);
	exit;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  YtAbv[h
#-----------------------------------------------------------
sub upload {
	my $num = shift;

	# gq擾
	my $ex = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : &error("gqs");
	$ex =~ tr/A-Z/a-z/;
	if ($ex eq '.jpeg') { $ex = '.jpg'; }

	# gq`FbN
	my %ex;
	foreach ( split(/,/, $cf{extension}) ) {
		$ex{".$_"}++;
	}
	if (!defined($ex{$ex})) { &error("Ȃgqł  $ex"); }

	# Ytt@C`
	my $upfile = "$cf{imgdir}/$num$ex";

	# Abv[h
	my $buf;
	open(UP,"+> $upfile") or &error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666,$upfile);

	# 摜TCY擾
	my ($w,$h);
	if ($ex eq ".jpg") { ($w,$h) = &j_size($upfile); }
	elsif ($ex eq ".gif") { ($w,$h) = &g_size($upfile); }
	elsif ($ex eq ".png") { ($w,$h) = &p_size($upfile); }

	return ($ex,$w,$h);
}

#-----------------------------------------------------------
#  JPEGTCYF
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFTCYF
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGTCYF
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}


1;

